package com.sa.ibiz.demo.demo.service.dto;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.sa.ibiz.demo.ibizutil.domain.ParentData;
import com.sa.ibiz.demo.demo.domain.WFAction;
import org.springframework.util.StringUtils;
import lombok.Data;
import java.util.Map;
import java.sql.Timestamp;
import com.sa.ibiz.demo.ibizutil.service.SearchFilterBase;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.sa.ibiz.demo.ibizutil.helper.DataGridCustomSearchHelper;
import com.alibaba.fastjson.JSONObject;
@Data
@JsonIgnoreProperties(ignoreUnknown = true)
public class WFActionSearchFilter extends SearchFilterBase {

	private String query;
	private Page page;
	private QueryWrapper<WFAction> selectCond;
	private JSONObject customsearchval;
	public WFActionSearchFilter(){
		this.page =new Page<WFAction>(1,Short.MAX_VALUE);
		this.selectCond=new QueryWrapper<WFAction>();	
	}

	/**
	 * 设定自定义查询条件，在原有SQL基础上追加该SQL
	 */
	public void setCustomCond(String sql)
	{
		this.selectCond.apply(sql);
	}

	private String n_wfactionname_like;

	public void setN_wfactionname_like(String n_wfactionname_like) {
        this.n_wfactionname_like = n_wfactionname_like;
        if(!StringUtils.isEmpty(this.n_wfactionname_like)){
            this.selectCond.like("wfactionname", n_wfactionname_like);
        }
    }
	private String n_wfworkflowid_eq;

	public void setN_wfworkflowid_eq(String n_wfworkflowid_eq) {
        this.n_wfworkflowid_eq = n_wfworkflowid_eq;
        if(!StringUtils.isEmpty(this.n_wfworkflowid_eq)){
            this.selectCond.eq("wfworkflowid", n_wfworkflowid_eq);
        }
    }
	private String n_wfworkflowname_eq;

	public void setN_wfworkflowname_eq(String n_wfworkflowname_eq) {
        this.n_wfworkflowname_eq = n_wfworkflowname_eq;
        if(!StringUtils.isEmpty(this.n_wfworkflowname_eq)){
            this.selectCond.eq("wfworkflowname", n_wfworkflowname_eq);
        }
    }
	private String n_wfworkflowname_like;

	public void setN_wfworkflowname_like(String n_wfworkflowname_like) {
        this.n_wfworkflowname_like = n_wfworkflowname_like;
        if(!StringUtils.isEmpty(this.n_wfworkflowname_like)){
            this.selectCond.like("wfworkflowname", n_wfworkflowname_like);
        }
    }

	public void setSrfparentdata(Map<String, String> srfparentdata) {
		this.srfparentdata = srfparentdata;
		String strParentkey=this.getSrfparentdata().get("srfparentkey");
		if(this.srfparentdata.containsKey("srfparentmode")&& this.getSrfparentdata().get("srfparentmode").equals("DER1N_WFACTION_WFWORKFLOW_WFWORKFLOWID"))
			if(StringUtils.isEmpty(strParentkey)){
				this.setN_wfworkflowid_eq("NA");
			}
			else{
				this.setN_wfworkflowid_eq(strParentkey);
			}
	}

	/**
	 * 启用快速搜索
	 */
	public void setQuery(String query)
	{
		 this.query=query;
		 if(!StringUtils.isEmpty(query)){
			this.selectCond.or().like("wfactionname",query);
		 }
	}

	/**
	 * 自定义查询
	 * @param customsearchval
	 */
	public void setCustomsearchval(JSONObject customsearchval) {
		this.customsearchval = customsearchval;
		if(!StringUtils.isEmpty(customsearchval)){
			DataGridCustomSearchHelper customSearchHelper= DataGridCustomSearchHelper.getInstance();
			String customSql =customSearchHelper.parseCustomVal(customsearchval);
			this.selectCond.apply(customSql);
		}
	}

}